EDIT - bug #6404

StackOverflow when compiling large java classes in Java8 (jdk1.8)
02/02/2017 01:06 PM - Patrick Plitzner

Status: Rejected Start date:

Priority: Highest Due date:

Assignee: Patrick Plitzner % Done: 0%
Category: platform Estimated time: 0:00 hour
Target version:

Severity: normal Found in Version:

Description

After updating to Java 8 compiling via mvn clean install results in a StackOverflow. (compiling in Eclipse works because it uses its

own javac)

This can happen because of very large java files (MarkupTransformer.java in this case)

This can be solved by increasing the stack size for the maven compile process in the pom.xml (You have to update the
maven-compiler-plugin to use the arguments)

<plugin>
<groupId>org.apache.maven.plugins</groupId>

<artifactId>maven-compiler-plugin</artifactId>

<version>3.6.1</version>

<configuration>

arge java

<source>${java.codelevel}</source>
<target>${java.codelevel}</target>

<!-— fork has to be true to allow to set the compile args —-—>
<fork>true</fork>
<compilerArgs>
<arg>-J-XssdM</arg><!-- Increase stack size to avoid StackOverflow during parsing of 1

classes——>

</compilerArgs>

</configuration>

</plugin>

We anyway decided to split up the MarkupTransformer class in order to have no customized settings for the maven-compiler-plugin.

stacktrace:

The system is out of resources.

Consult the following stack trace for

java.lang.StackOverflowError
Related issues:
Related to EDIT - task #6401: Update working environment to jdk 1.8

Related to EDIT - bug #6406: Refactor MarkupTransformer class which is too large
Related to EDIT - bug #6407: Upgrade maven compiler plugin to latest version

Closed
In Progress
New

Associated revisions

Revision 3¢5fd363 - 02/01/2017 11:57 AM - Patrick Plitzner
ref #6401 Updated cdmlib to jdk1.8

e Had to increase the parser stack size to avoid StackOverflow when parsing large java classes

o https://maven.apache.org/plugins/maven-compiler-plugin/compile-mojo.html#compilerArgs
o http://stackoverflow.com/questions/29984739/stackoverflowerror-java-1-8

Revision 3ee9fbcc - 02/04/2017 10:02 AM - Andreas Miiller
ref #6401, ref #6404 doc

History

#1 - 02/02/2017 01:06 PM - Patrick Plitzner
- Related to task #6401: Update working environment to jdk 1.8 added

#2 - 02/02/2017 01:09 PM - Patrick Plitzner

- Status changed from New to Closed

Andreas M.: Can you link the ticket for the MarkupTransformer class to this ticket?

#3 - 02/02/2017 04:51 PM - Andreas Miuller

- Related to bug #6406: Refactor MarkupTransformer class which is too large added

#4 - 02/02/2017 10:59 PM - Andreas Miuller

- Status changed from Closed to Rejected

We decided to NOT use the compilerArgs but rather try to fix the large class issue #6406.

Also the above compilerArgs don't work with maven compiler plugin <3.x but currently we still can't upgrade (blocked by #6407)

#5 - 02/02/2017 11:00 PM - Andreas Miuller

- Related to bug #6407: Upgrade maven compiler plugin to latest version added

#6 - 02/02/2017 11:04 PM - Andreas Miuller

@PP: if you still if the old version of the compilerArgs, could you please add them to the ticket?

#7 - 02/04/2017 10:13 AM - Andreas Miiller

- Priority changed from New to Highest

#8 - 03/11/2017 06:41 PM - Andreas Miuller

- Target version deleted (Release 4.6)
